package org.rcisoft.business.bchapter.dao;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.business.bchapter.entity.BPChapter;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* Created with  on 2020-7-1 18:57:28.
*/
@Repository
public interface BPChapterRepository extends BaseMapper<BPChapter> {

    /**
    * 分页查询 bPChapter
    *
    */
    @Select("<script>select * from b_p_chapter where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BPChapter> queryBPChapters(BPChapter bPChapter);


    @Insert("<script>" +
            " insert into b_p_chapter VALUES " +
            "<foreach collection=\"list\" item=\"item\" index=\"index\" separator=\",\"> " +
            "(#{item.businessId}, #{item.createBy}, #{item.createDate},#{item.updateBy}, #{item.updateDate}, #{item.delFlag}, " +
            "#{item.flag}, #{item.remarks}, #{item.chapterName}, #{item.chapterLevel}, #{item.pid}, #{item.chapterUrl}," +
            "#{item.mdFile}, #{item.isTest}, #{item.lessonId}, #{item.classHour}, #{item.state}, " +
            "#{item.sort}, #{item.corpId}, #{item.automatic}, #{item.experimentType}, #{item.courseTime})" +
            "</foreach>  </script>")
    int insertList(List<BChapter> list);

    /**
     * 批量删除 课程
     * @param list
     * @return
     */
    @Delete("<script>" +
            " delete from b_p_chapter where business_id in " +
            "<foreach item='item' index='index' collection='list' open='(' separator=',' close=')'> #{item.businessId} </foreach> "+
            "</script>")
    int deleteList(List<BChapter> list);
}

