package org.rcisoft.business.bdictionary.controller;


/*固定导入*/
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.bdictionary.dto.ColumConfigDTO;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import javax.validation.Valid;


import org.rcisoft.business.bdictionary.entity.BDictionary;
import org.rcisoft.business.bdictionary.service.BDictionaryService;

/**
* Created by  on 2019-9-29 16:21:48.
*/
@Api(tags = "11 栏目配置")
@RestController
@RequestMapping("bdictionary")
public class BDictionaryController extends PaginationController<BDictionary> {

    @Autowired
    private BDictionaryService bDictionaryServiceImpl;


//    @ApiOperation(value="添加", notes="添加")
//    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
//    @PostMapping(value = "/add")
//    public Result add(CurUser curUser,@Valid BDictionary bDictionary, BindingResult bindingResult) {
//        PersistModel data = bDictionaryServiceImpl.save(bDictionary);
//        return Result.builder(data,
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        bDictionary);
//    }
//
//    @ApiOperation(value="逻辑删除", notes="逻辑删除")
//    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
//    @DeleteMapping("/delete/{id:\\w+}")
//    public Result delete(@PathVariable String id) {
//        BDictionary bDictionary = new BDictionary();
//        bDictionary.setBusinessId(id);
//        PersistModel data = bDictionaryServiceImpl.remove(bDictionary);
//        return Result.builder(data,
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        id);
//    }

//    @ApiOperation(value="修改", notes="修改")
//    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
//    @PutMapping("/update/{id:\\w+}")
//    public Result update(@Valid BDictionary bDictionary, BindingResult bindingResult) {
//        bDictionary.setToken(getToken());
//        PersistModel data = bDictionaryServiceImpl.merge(bDictionary);
//        return Result.builder(data,
//            MessageConstant.MESSAGE_ALERT_SUCCESS,
//            MessageConstant.MESSAGE_ALERT_ERROR,
//        bDictionary);
//    }


    @ApiOperation(value="1101 查看栏目配置", notes="查看栏目配置")
    @GetMapping(value = "/columnConfiguration")
    public Result columnConfiguration(CurUser curUser) {
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                bDictionaryServiceImpl.findAllColumnConfig(curUser));
    }

    @ApiOperation(value="1102 更新栏目配置", notes="查看栏目配置")
    @PostMapping(value = "/updateConfiguration")
    public Result updateConfiguration(CurUser curUser, @Valid ColumConfigDTO param, BindingResult bindingResult) {
        return Result.builder(new PersistModel(bDictionaryServiceImpl.updateConfiguration(param)),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                param);
    }

}
