package org.rcisoft.business.bdictionary.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bdictionary.entity.BDictionary;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-9-29 16:21:48.
*/
@Repository
public interface BDictionaryRepository extends BaseMapper<BDictionary> {

    /**
    * 分页查询 bDictionary
    *
    */
    @Select("<script>" +
            " select * from b_dictionary where 1=1 "+
            " and del_flag = !1  and flag = 1 "+
            " and corp_id = #{curUser.corpId} "+
            " <if test=\"configList != null and configList.size()>0 \">and type in " +
            " <foreach item='item' index='index' collection='configList' open='(' separator=',' close=')'> #{item} </foreach> " +
            " </if> " +
            "  order by CAST(sort AS UNSIGNED) "+
            " </script>")
    @ResultMap(value = "BaseResultMap" )
    List<BDictionary> findAllColumnConfig(@Param("curUser") CurUser curUser, @Param("configList") List<String> configList);
}

