package org.rcisoft.business.bdiscuss.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.bdiscuss.dto.BDiscussDto;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bdiscuss.entity.BDiscuss;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-9-25 9:03:09.
*/
@Repository
public interface BDiscussRepository extends BaseMapper<BDiscuss> {

    /**
    * 分页查询 bDiscuss
    *
    */
    @Select("<script>select * from b_discuss where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BDiscuss> queryBDiscusss(BDiscuss bDiscuss);

    @Select("<script> SELECT " +
            " bd.*, " +
            " su.NAME AS studentName,  " +
            " rbd.student_id AS replyToId,  " +
            " rsu.NAME AS replyToName  " +
            "FROM " +
            " b_discuss bd " +
            " LEFT JOIN s_user su ON su.business_id = bd.student_id  " +
            " LEFT JOIN b_discuss rbd ON bd.reply_id = rbd.business_id  " +
            " AND rbd.del_flag = '0'  " +
            " AND rbd.flag = '1' " +
            " LEFT JOIN s_user rsu ON rsu.business_id = rbd.student_id  " +
            "WHERE " +
            " 1 = 1  " +
            " AND bd.del_flag = '0'  " +
            " AND bd.flag = '1' "
            + "<if test=\"lessonId !=null and lessonId != '' \">and bd.lesson_id = #{lessonId} </if> "
            + "and bd.pid = #{pid} " +

//            "and bd.corp_id = #{corpId} " +

            " order by bd.update_date desc "
            + "</script>")
    @ResultMap(value = "BaseResultMapDto" )
    List<BDiscussDto> getDiscussByLessonId(@Param("lessonId") String lessonId, @Param("pid") String pid, @Param("corpId") String corpId);

    @Update("<script>update b_discuss " +
            "  <set>"+
            "    <if test='updateBy != null'>update_by=#{updateBy},</if>"+
            "    <if test='updateDate != null'>update_date=#{updateDate},</if>"+
            "   del_flag = 1 "+
            "  </set>"+
            " where pid = #{businessId}</script>")
    int logicalDeleteSon(BDiscuss bDiscuss);
}

