package org.rcisoft.business.bexternallink.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.bexternallink.dto.FindListDTO;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bexternallink.entity.BExternalLink;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.stereotype.Repository;


import java.util.List;
import java.util.Map;

/**
 * Created with  on 2019-11-13 13:28:38.
 */
@Repository
public interface BExternalLinkRepository extends BaseMapper<BExternalLink> {

    /**
     * 分页查询 bExternalLink
     */
    @Select("<script>select * from b_external_link where 1=1 " +
            " and del_flag = 0 and flag = 1 " +
            " and corp_id = #{param.corpId} " +
            " <if test=\"param.type !=null and param.type != ''\">and type = #{param.type}</if>" +
            " <if test=\"param.title !=null and param.title != ''\">and title like CONCAT('%',#{param.title},'%')</if>" +
            " order by CAST(sort AS UNSIGNED) asc " +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<BExternalLink> queryBExternalLinks(@Param("param") FindListDTO findListDTO);

    /**
     * 按id查询个数
     *
     * @param id
     * @return
     */
    @Select("<script>select count(business_id) from b_external_link where del_flag='0' and flag = '1' and business_id=#{id} " +
            "</script>")
    int selectCountById(String id);

    /**
     * 根据企业id查询外链个数
     *
     * @return
     */
    @Select("<script>select count(1) from b_external_link where " +
            " del_flag = 0 and flag = 1 " +
            " and corp_id = #{corpId} " +
            "</script>")
    int selectCountExternalLink(String corpId);

    /**
     * 获取sort最大值 +1
     *
     * @return
     */
    @Select("<script>select DISTINCT IFNULL((select max(sort) from b_external_link where " +
            "del_flag = 0 and flag = 1 ),0)+1 as sort</script>")
    int selectMaxSort();

    //重新排序
    @Update("<script> <foreach collection=\"orderMap.entrySet()\" index=\"key\" item=\"value\" separator=\";\"> " +
            "update b_external_link " +
            "set sort = #{value} " +
            " WHERE business_id = #{key} " +
            "</foreach></script>")
    int updateExternalLinkOrder(@Param("orderMap") Map<String,Object> orderMap);
}

