package org.rcisoft.business.bexternallink.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;

@Data
public class AddOrUpdateDTO {

    @ApiModelProperty(value = "主键id" ,required = false, dataType = "varchar")
    private String businessId;

    @NotBlank(message = "标题不能为空")
    @Length(max = 50,message = "长度最大为50")
    @ApiModelProperty(value = "标题" ,required = true, dataType = "varchar")
    private String title;

    @ApiModelProperty(value = "外部URL",required = true, dataType = "varchar")
    private String externalUrl;

    @ApiModelProperty(value = "手机图标",required = false, dataType = "varchar")
    private String mobileLogo;

    @ApiModelProperty(value = "客户端图标",required = false, dataType = "varchar")
    private String computerLogo;

    @ApiModelProperty(value = "备注",required = false, dataType = "varchar")
    private String remarks;

    @ApiModelProperty(value = "类型（0：手机，1：跨平台,2: PC）",required = true, dataType = "varchar")
    private String type;

    private String userId;

    private String corpId;

}
