package org.rcisoft.business.bfile.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.business.bcourse.entity.BCourse;
import org.rcisoft.business.bfile.entity.BFile;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with gaowenfneg on 2017-10-9 14:34:56.
*/
@Repository
public interface BFileRepository extends BaseMapper<BFile> {
    @Update("UPDATE b_chapter set course_time = #{time} where business_id =#{id}")
    int updateVideoTimeInChapter(@Param("time") String time,@Param("id") String id);


    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_file where del_flag != 1 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap" )
    List<BFile> queryBVideos(Map<String, Object> param);

    @Select("<script>SELECT * from b_file " +
            "where chapter_id = #{chapterId} and del_flag != 1 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap" )
    BFile selectInfoByChapterId(String chapterId);

    @Select("<script>SELECT * FROM b_file WHERE chapter_id = #{chapterId} and del_flag != 1 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap" )
    BFile queryFileUrlByChapterId(String chapterId);


    @Select("<script>SELECT * FROM b_file WHERE chapter_id = #{chapterId} and del_flag != 1 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap" )
    BFile queryBVideoByChapterId(String chapterId);

    /**
     * 添加文件信息到file表
     * @return
     */
    @Insert("INSERT INTO `b_file` " +
            "(business_id,lesson_id,chapter_id,file_name,video_url,file_url,type,flag,del_flag,remarks,create_by,update_by,update_date,create_date,file_size,file_time) " +
            "VALUES (#{businessId}, #{lessonId}, #{chapterId}, #{fileName}, #{videoUrl}, #{fileUrl}, #{type}, #{flag}, #{delFlag}, #{remarks}, #{createBy}, #{updateBy}, #{updateDate}, #{createDate},#{fileSize},#{fileTime})")
    int insertUploadFile(BFile bFile);

    /**
     * 添加文件信息到file表
     * @return
     */
    @Insert("<script>" +
            "INSERT INTO `b_file` " +
            "(business_id,lesson_id,chapter_id,file_name,video_url,file_url,type,flag,del_flag,remarks,create_by,update_by,update_date,create_date,file_size,file_time) " +
            "VALUES " +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "(#{item.businessId}, #{item.lessonId}, #{item.chapterId}, #{item.fileName}, #{item.videoUrl}, #{item.fileUrl}, #{item.type}, " +
            "#{item.flag}, #{item.delFlag}, #{item.remarks}, #{item.createBy}, #{item.updateBy}, #{item.updateDate}, #{item.createDate},#{item.fileSize},#{item.fileTime})" +
            "</foreach></script>")
    int insertUploadFileList(List<BFile> bFiles);

    @Update("update b_file set " +
            "file_name = #{fileName} , " +
            "video_url = #{videoUrl} ," +
            "file_url = #{fileUrl} ," +
            "type = #{type} ," +
            "file_size = #{fileSize}," +
            "file_time = #{fileTime}," +
            "update_by = #{updateBy}," +
            "update_date = #{updateDate}" +
            "where chapter_id =#{chapterId}")
    int updateUploadFile(BFile bFile);


    /**
     * 根据 课程id 查询 文件集合
     * @param id
     * @return
     */
    @Select(" select * from b_file " +
            " where chapter_id in (select business_id from b_chapter where lesson_id = #{id} and del_flag != 1 and flag = 1 and chapter_level = 2) " +
            " and del_flag != 1 and flag = 1 ")
    @ResultMap(value = "BaseResultMap" )
    List<BFile> getFileByLessonId(String id);


}

