package org.rcisoft.business.bfile.dao;


import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bfile.entity.BTrainFile;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-10-21 17:51:47.
*/
@Repository
public interface BTrainFileRepository extends BaseMapper<BTrainFile> {

    /**
    * 分页查询 bTrainFile
    *
    */
    @Select("<script>select * from b_train_file where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTrainFile> queryBTrainFiles(BTrainFile bTrainFile);
    /**
    * 根据课程查询
    *
    */
    @Select("<script>select * from b_train_file where 1=1 "
            + "and del_flag != 1  "
            + "and flag = 1 "
            + "and lesson_id = #{lessonId} "
            + " order by CAST(sort AS UNSIGNED) asc "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTrainFile> queryByLessonId(@Param("lessonId") String lessonId);


    @Insert("<script>INSERT INTO b_train_file " +
            "(create_date,create_by,update_date,update_by," +
            "del_flag,flag,business_id,remarks, " +
            "lesson_id,file_name,video_url,file_url,file_size,type,sort)VALUES" +
            "<foreach collection=\"param\" item=\"item\" separator=\",\">" +
            "(#{item.createDate},#{item.createBy},#{item.updateDate},#{item.updateBy}," +
            "#{item.delFlag},#{item.flag},#{item.businessId},#{item.remarks}," +
            "#{item.lessonId},#{item.fileName},#{item.videoUrl},#{item.fileUrl}," +
            "#{item.fileSize},#{item.type},#{item.sort})" +
            "</foreach></script>")
    int insertTrainFileList(@Param("param") List<BTrainFile> param);

    @Update("update b_train_file set del_flag = 1 where lesson_id = #{lessonId}")
    int deleteByLessonId(@Param("lessonId") String lessonId);

}

