package org.rcisoft.business.bfile.service.impl;

import org.rcisoft.business.bfile.dao.BPFileRepository;
import org.rcisoft.business.bfile.entity.BPFile;
import org.rcisoft.business.bfile.service.BPFileService;
import org.rcisoft.core.model.PersistModel;

import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by  on 2020-7-1 18:57:28.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BPFileServiceImpl implements BPFileService {

    @Autowired
    private BPFileRepository bPFileRepository;


    /**
    * 保存 平台记录企业文件表
    * @param bPFile
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(BPFile bPFile){
        //增加操作
        UserUtil.setCurrentPersistOperation(bPFile);
        int line = bPFileRepository.insertSelective(bPFile);
        return new PersistModel(line);
    }

    /**
    * 删除 平台记录企业文件表
    * @param bPFile
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel remove(BPFile bPFile){
        int line = bPFileRepository.deleteByPrimaryKey(bPFile.getBusinessId());
        return new PersistModel(line);
    }



}
