package org.rcisoft.business.blabel.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Entity
@Table(name = "b_label")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BLabel extends IdEntity<BLabel> {

    /*标签名称*/
    @Length(min = 0,max = 64,message = "标签名称过长")
    @ApiModelProperty(value = "标签名")
    private String lName;

    @Transient
    @ApiModelProperty(value = "新消息的个数")
    private int newCount;

}
