package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.blesson.dto.LessonAndUserDTO;
import org.rcisoft.business.blesson.entity.BCollect;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-10-20 22:52:29.
*/
@Repository
public interface BCollectRepository extends BaseMapper<BCollect> {

    /**
    * 分页查询 bCollect
    *
    */
    @Select("<script>select * from b_collect where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BCollect> queryBCollects(BCollect bCollect);

    /**
     * 根据课程id PersonId查询
     */
    @Select("<script>select * from b_collect where 1=1 " +
            "and del_flag = 0 and flag = 1 " +
            "AND person_id = #{userId} " +
            "and lesson_id = #{lessonId}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BCollect> selectByPersonAndLesson(LessonAndUserDTO param);


    /**
     * 查询关系表中是否已存在此关系
     * @param personId
     * @param lessonId
     * @return
     */
    @Select("select * from b_collect where person_id =#{personId} and lesson_id =#{lessonId} ")
    List<BCollect> selectOneData(@Param("personId") String personId,@Param("lessonId") String lessonId);

    /**
     * 取消收藏课程或培训
     * @param personId
     * @param lessonId
     * @return
     */
    @Delete("delete from b_collect where person_id =#{personId} and lesson_id =#{lessonId} ")
    int notColletLesson(@Param("personId") String personId,@Param("lessonId") String lessonId);



    @Select("select count(1) from b_collect " +
            " where 1=1 " +
            " and person_id = #{curUser.userId} " +
            " and lesson_id = #{lessonId} ")
    int selectCountbyLessonAndUser(@Param("curUser")CurUser curUser, @Param("lessonId")String lessonId);


}

