package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.blesson.dto.FindLessonRecommendDTO;
import org.rcisoft.business.blesson.dto.FindLessonRecommendRspDTO;
import org.rcisoft.business.blesson.entity.BRecommend;
import org.rcisoft.business.blesson.entity.BRecommendSon;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-10-10 16:08:10.
*/
@Repository
public interface BRecommendRepository extends BaseMapper<BRecommend> {

    /**
    * 分页查询 bRecommend
    *
    */
    @Select("<script>select * from b_recommend where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BRecommend> queryBRecommends(BRecommend bRecommend);

    @Update({"<script>",
            " update b_recommend",
            "  <set>",
            "    <if test='updateBy != null'>update_by=#{updateBy},</if> ",
            "    <if test='updateDate != null'>update_date=#{updateDate},</if> ",
            "    <if test='delFlag != null'>del_flag=#{delFlag},</if> ",
            "    <if test='flag != null'>flag=#{flag},</if> ",
            "    <if test='remarks != null'>remarks=#{remarks},</if> ",
            "    <if test='recommend_person != null'>recommend_person=#{recommendPerson},</if> ",
            "    <if test='lesson_id != null'>lesson_id=#{lessonId},</if> ",
            "    <if test='type != null'>type=#{type},</if> ",
            "    <if test='corp_id != null'>corp_id=#{corp_id},</if> ",
            "  </set>",
            " where lesson_id=#{lessonId} ",
            "</script>"})
    int updateByLessonId(BRecommend bRecommend);

    @Delete("<script>DELETE from b_recommend_son where recommend_id=#{businessId}</script>")
    int deleteRecommendSon(BRecommend bRecommend);

    @Select("<script>select business_id from b_recommend where " +
            "del_flag != 1 and flag = 1 " +
            "and lesson_id = #{lessonId}</script>")
    List<String> selectIdByLessonId(String lessonId);

    @Insert("<script>INSERT INTO b_recommend_son" +
            "(business_id,recommend_id,type,target_id,sort)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "(#{item.businessId},#{item.recommendId},#{item.type},#{item.targetId},#{item.sort})" +
            "</foreach></script>")
    int insertBRecommendSons(List<BRecommendSon> bRecommendSons);


    @Select("<script>select brs.business_id businessId, brs.type type, brs.target_id targetId, su.name targetName,su.account_id accountId " +
            " from b_recommend_son brs left join b_recommend br on brs.recommend_id = br.business_id " +
            " left join b_lesson bl on br.lesson_id = bl.business_id " +
            " left join s_user su on brs.target_id = su.business_id " +
            " where 1=1 " +
            " and br.del_flag != 1 and br.flag = 1 " +
            " and bl.del_flag != 1 and bl.flag = 1 " +
//            " and su.del_flag != 1 and su.flag = 1 " +

//            " and bl.corp_id = #{corpId} "+
//            " and su.corp_id = #{corpId} "+

            " <if test=\"viewParam!=null and viewParam != ''\">and su.name like CONCAT('%',#{viewParam},'%')</if>" +
            " and brs.type = '0' "+
            " and br.lesson_id = #{lessonId}" +
            " order by CAST(brs.sort AS UNSIGNED) asc "+
            "</script>")
    List<FindLessonRecommendRspDTO> queryRecommendPersonByLessonId(FindLessonRecommendDTO param);

    @Select("<script>select brs.business_id businessId, brs.type type, brs.target_id targetId " +
            " from b_recommend_son brs left join b_recommend br on brs.recommend_id = br.business_id " +
            " left join b_lesson bl on br.lesson_id = bl.business_id " +
            " where 1=1 " +
            " and br.del_flag != 1 and br.flag = 1 " +
            " and bl.del_flag != 1 and bl.flag = 1 " +

//            " and bl.corp_id = #{corpId} "+

            " and brs.type = '1' "+
            "   <if test=\"departs != null and departs.size() > 0 \"> " +
            "        and brs.target_id in " +
            "       <foreach item='item' index='index' collection='departs' open='(' separator=',' close=')'> #{item.id} </foreach> " +
            "   </if> " +

            " and br.lesson_id = #{lessonId}" +
            " order by CAST(brs.sort AS UNSIGNED) asc "+
            "</script>")
    List<FindLessonRecommendRspDTO> queryRecommendDepartByLessonId(FindLessonRecommendDTO param);
}

