package org.rcisoft.business.blesson.entity;

import lombok.*;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.*;
import java.util.Date;

/**
* Created with  on 2020-7-1 18:57:28.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_p_lesson")
public class BPLesson  extends IdEntity<BPLesson> {



     /**
     * @desc 课程编号
     * @column code
     * @default 
     */
     private String code;

     /**
     * @desc 课程名称
     * @column lesson_name
     * @default 
     */
     private String lessonName;

     /**
     * @desc 默认封面图片url
     * @column default_url
     * @default 
     */
     private String defaultUrl;

     /**
     * @desc 学时
     * @column class_hour
     * @default 
     */
     private String classHour;

     /**
     * @desc 讲师id
     * @column lecturer_id
     * @default 
     */
     private String lecturerId;

     /**
     * @desc 发布状态（0：待发布 1：审核中 2：已发布 3：已驳回 4:已关闭）
     * @column release_state
     * @default 
     */
     private String releaseState;

     /**
     * @desc 课程分类
     * @column course_id
     * @default 
     */
     private String courseId;

     /**
     * @desc 选课人数
     * @column person_number
     * @default 
     */
     private String personNumber;

     /**
     * @desc 课程时长（当课时为1时显示）
     * @column course_time
     * @default 
     */
     private String courseTime;

     /**
     * @desc 课程描述
     * @column course_description
     * @default 
     */
     private String courseDescription;

     /**
     * @desc 可见范围
     * @column view_range
     * @default 
     */
     private String viewRange;

     /**
     * @desc 发布时间
     * @column release_date
     * @default 
     */
     private Date releaseDate;

     /**
     * @desc 关闭时间
     * @column close_date
     * @default 
     */
     private Date closeDate;

     /**
     * @desc 课程类型（0：课程 1：培训）
     * @column lesson_type
     * @default 
     */
     private String lessonType;

     /**
     * @desc 评论数
     * @column discuss_number
     * @default 
     */
     private String discussNumber;

     /**
     * @desc 推荐（0：不推荐 1：推荐）
     * @column recommend
     * @default 
     */
     private String recommend;

     /**
     * @desc 关注数
     * @column collect_number
     * @default 
     */
     private String collectNumber;

     /**
     * @desc 热度
     * @column hot_number
     * @default 
     */
     private String hotNumber;

     /**
     * @desc 企业id
     * @column corp_id
     * @default 
     */
     private String corpId;

     /**
     * @desc 报名开始时间
     * @column apply_start_date
     * @default 
     */
     private Date applyStartDate;

     /**
     * @desc 报名结束时间
     * @column apply_over_date
     * @default 
     */
     private Date applyOverDate;

     /**
     * @desc 培训开始时间
     * @column train_start_date
     * @default 
     */
     private Date trainStartDate;

     /**
     * @desc 培训结束时间
     * @column train_over_date
     * @default 
     */
     private Date trainOverDate;

     /**
     * @desc 培训最大报名人数
     * @column max_apply_person
     * @default 
     */
     private String maxApplyPerson;

     /**
     * @desc 培训地址
     * @column train_address
     * @default 
     */
     private String trainAddress;

     /**
     * @desc 培训签到时间（培训开始前 分钟数）
     * @column train_sign_time
     * @default 
     */
     private String trainSignTime;

     /**
     * @desc 二维码
     * @column qr_code
     * @default 
     */
     private String qrCode;

     /**
     * @desc 
     * @column value_consume
     * @default 0
     */
     private String valueConsume;

     /**
     * @desc 
     * @column value_gain
     * @default 0
     */
     private String valueGain;

     /**
     * @desc 积分修改时间
     * @column value_update_date
     * @default 
     */
     private Date valueUpdateDate;


}

