package org.rcisoft.business.blessonlog.dao;

import org.apache.ibatis.annotations.Insert;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.blessonlog.entity.BLessonLog;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2020-7-1 18:57:28.
*/
@Repository
public interface BLessonLogRepository extends BaseMapper<BLessonLog> {

    /**
    * 分页查询 bLessonLog
    *
    */
    @Select("<script>select * from b_lesson_log where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> " +
            " order by create_date desc "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BLessonLog> queryBLessonLogs(BLessonLog bLessonLog);


    @Insert("<script>" +
            " insert into b_lesson_log VALUES " +
            "<foreach collection=\"list\" item=\"item\" index=\"index\" separator=\",\"> " +
            "(#{item.businessId}, #{item.content}, #{item.lessonId}, #{item.createBy}, #{item.createDate}, " +
            "#{item.updateBy}, #{item.updateDate}, #{item.delFlag}, #{item.flag}, #{item.remarks}, #{item.corpId})" +
            "</foreach>  </script>")
    int insertList(List<BLessonLog> list);
}

