package org.rcisoft.business.blessonlog.service.impl;

import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.business.blessonlog.dao.BLessonLogRepository;
import org.rcisoft.business.blessonlog.entity.BLessonLog;
import org.rcisoft.business.blessonlog.service.BLessonLogService;

import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by  on 2020-7-1 18:57:28.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BLessonLogServiceImpl  implements BLessonLogService {

    @Autowired
    private BLessonLogRepository bLessonLogRepository;


    /**
    * 保存 课程日志
    * @param bLessonLog
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(BLessonLog bLessonLog){
        //增加操作
        UserUtil.setCurrentPersistOperation(bLessonLog);
        int line = bLessonLogRepository.insertSelective(bLessonLog);
        return new PersistModel(line);
    }


    /**
    * 分页查询 课程日志
    * @param bLessonLog
    * @return
    */
    @Override
    public List<BLessonLog> findAllByPagination(PageUtil<BLessonLog> paginationUtility,BLessonLog bLessonLog){
        bLessonLog.setNormal();
        return bLessonLogRepository.queryBLessonLogs(bLessonLog);
    }


}
