package org.rcisoft.business.bmessage.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.util.UserUtil;
import javax.validation.Valid;
import javax.websocket.server.PathParam;


import org.rcisoft.business.bmessage.entity.BMessage;
import org.rcisoft.business.bmessage.service.BMessageService;

import java.util.List;

/**
* Created by  on 2019-11-25 10:55:04.
*/
@RestController
@RequestMapping("bmessage")
public class BMessageController extends PaginationController<BMessage> {

    @Autowired
    private BMessageService bMessageServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(CurUser curUser,@Valid BMessage bMessage, BindingResult bindingResult) {
        PersistModel data = bMessageServiceImpl.save(bMessage);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        bMessage);
    }

    @ApiOperation(value="逻辑删除", notes="逻辑删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
    @DeleteMapping("/delete/{id:\\w+}")
    public Result delete(CurUser curUser,@Valid String id, BindingResult bindingResult) {
        BMessage bMessage = new BMessage();
        bMessage.setBusinessId(id);
        PersistModel data = bMessageServiceImpl.remove(bMessage);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        id);
    }

    @ApiOperation(value="修改", notes="修改")
    @ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")
    @PostMapping("/update")
    public Result update(CurUser curUser,@Valid BMessage bMessage, BindingResult bindingResult) {
        PersistModel data = bMessageServiceImpl.merge(curUser,bMessage);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        bMessage);
    }

    @ApiOperation(value="修改共享 ", notes="修改")
    @ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")
    @PostMapping("/updateSycn")
        public Result updateSycn(CurUser curUser,@Valid BMessage bMessage, BindingResult bindingResult) {
        PersistModel data = bMessageServiceImpl.updateSycn(curUser,bMessage);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        "1".equals(bMessage.getTimeValue())?"打开共享":"关闭共享");
    }


    @ApiOperation(value="查看  集合", notes="查看  集合")
    @GetMapping(value = "/query")
    public Result list(CurUser curUser) {
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                bMessageServiceImpl.findAll(curUser));
    }
}
