package org.rcisoft.business.bnotice.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2019-11-28 11:18:34.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_notice")
public class BNotice  extends IdEntity<BNotice> {

     @ApiModelProperty(value = "消息类型 OFFLINE_TRAIN:培训；REPLY_DISCUSS:评论；EXAM:考试；ONLINE_LESSON:课程")
     private String infoType;

     @ApiModelProperty(value = "消息内容")
     private String infoText;

     @ApiModelProperty(value = "接收人id")
     private String recipientId;

     @ApiModelProperty(value = "发送人id")
     private String senderId;

     @ApiModelProperty(value = "是否已读，0未读，1已读")
     private String readFlag;

     @ApiModelProperty(value = "查询参数")
     private String queryParam;

     @Transient
     @ApiModelProperty(value = "接收人集合（不传）")
     private List<String> recipientIds;

     @Transient
     @ApiModelProperty(value = "课程Id")
     private String lessonId;

     @Transient
     @ApiModelProperty(value = "头像")
     private String headPic;

     @Transient
     @ApiModelProperty(value = "发送人名称")
     private String senderName;

     @Transient
     private String userId;

     @Override
     public String toString() {
          return "BNotice{" +
                  "infoType='" + infoType + '\'' +
                  ", infoText='" + infoText + '\'' +
                  ", recipientId='" + recipientId + '\'' +
                  ", senderId='" + senderId + '\'' +
                  ", readFlag='" + readFlag + '\'' +
                  ", queryParam='" + queryParam + '\'' +
                  ", recipientIds=" + recipientIds +
                  ", lessonId='" + lessonId + '\'' +
                  ", headPic='" + headPic + '\'' +
                  ", senderName='" + senderName + '\'' +
                  ", userId='" + userId + '\'' +
                  ", businessId='" + businessId + '\'' +
                  ", token='" + token + '\'' +
                  ", remarks='" + remarks + '\'' +
                  ", createBy='" + createBy + '\'' +
                  ", createDate=" + createDate +
                  ", updateBy='" + updateBy + '\'' +
                  ", updateDate=" + updateDate +
                  ", delFlag='" + delFlag + '\'' +
                  ", flag='" + flag + '\'' +
                  ", corpId='" + corpId + '\'' +
                  '}';
     }
}

