package org.rcisoft.business.bpersonvalue.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

@Data
public class PersonValueDto {

    @ApiModelProperty(value = "用户id")
    public String personId;

    @ApiModelProperty(value = "事件")
    public String event;

    @ApiModelProperty(value = "0 发放 1 扣减")
    public String type;

    @ApiModelProperty(value = "积分数")
    @Length(min = 1,max =10,message = "长度最小为1,最大为10")
    public String value;

    @ApiModelProperty(value = "备注")
    @Length(min = 0,max = 300,message = "长度最小为0,最大为300")
    public String remarks;

    public String userId;

    public String corpId;
}
