package org.rcisoft.business.breleasevalue.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

@Data
public class LessonValueSettingQueryDto {

    @ApiModelProperty(value = "课程、培训名")
    @Length(max = 20,message = "长度最大为20")
    public String lessonName;

    @ApiModelProperty(value = "讲师名")
    @Length(max = 10,message = "长度最大为10")
    public String lecturerName;

    @ApiModelProperty(value = "积分消耗起始值")
    @Length(max = 10,message = "长度最大为10")
    public String valueConsumeStart;

    @ApiModelProperty(value = "积分消耗最大值")
    @Length(max = 10,message = "长度最大为10")
    public String valueConsumeEnd;

    @ApiModelProperty(value = "积分获得起始值")
    @Length(max = 10,message = "长度最大为10")
    public String valueGainStart;

    @ApiModelProperty(value = "积分获得最大值")
    @Length(max = 10,message = "长度最大为10")
    public String valueGainEnd;

    @ApiModelProperty(value = "状态 0未发布 2已发布 4已关闭 ")
    public String status;

    @ApiModelProperty(value = "培训状态 5培训未开始 6培训进行中 7培训已结束 ")
    public String trainStatus;

    @ApiModelProperty(value = "0 课程  1培训")
    public String type;

    @ApiModelProperty(value = "学习积分消耗排序 0正序  1倒序")
    public String valueConsumeSort;

    @ApiModelProperty(value = "学习积分奖励排序 0正序  1倒序")
    public String valueGainSort;

    @ApiModelProperty(value = "更新时间排序 0正序  1倒序")
    public String updateDateSort;
}
