package org.rcisoft.config;

import org.apache.poi.ss.formula.functions.T;
import org.rcisoft.core.aop.CurUserAspect;
import org.rcisoft.core.aop.EntityParamAspect;
import org.rcisoft.core.aop.IdGenAspect;
import org.rcisoft.core.aop.PageUtil;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

/**
 * Created by lcy on 18/1/21.
 */
@Configuration
public class AopConfig {


    /**
     * 分页 bean
     * @return
     */
    @Bean
    public PageUtil<T> pageUtil(){
        return new PageUtil<T>();
    }

    /**
     * id bean
     * @return
     */
    @Bean
    public IdGenAspect idGenAspect(){
        return new IdGenAspect();
    }

    /**
     * 用户 id 企业id
     * @return
     */
    @Bean
    public CurUserAspect curUserAspectt(){
        return new CurUserAspect();
    }

    /**
     *  web param validation
     * @return
     */
    @Bean
    public EntityParamAspect entityParamAspect(){
        return new EntityParamAspect();
    }


    @Bean
    public RestTemplate restTemplate()
    {
        SimpleClientHttpRequestFactory requestFactory = new SimpleClientHttpRequestFactory();
        requestFactory.setConnectTimeout(500000);
        requestFactory.setReadTimeout(300000);
        RestTemplate restTemplate = new RestTemplate(requestFactory);
        return restTemplate;
    }
}
