package org.rcisoft.core.task;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.util.DeleteFileUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.io.File;

@Component
@ConditionalOnProperty(
        prefix = "deleteZipJob",
        name = {"openTask"},
        havingValue = "true"
)
@Slf4j
public class DeleteZipTask {

    @Autowired
    private Global global;

    @Scheduled(cron = "${deleteZipJob.taskInterval:0 0 2 * * ?}")
    @Transactional(propagation = Propagation.REQUIRED, readOnly = false)
    public void work() throws Exception {
        String filePath = global.getBASE_UPLOAD_SERVER_LOCATION() + global.getCOURSE_LOCATION() + File.separator + global.getZIP_LOCATION();
        DeleteFileUtil.delAllFile(filePath);
    }

}
