package org.rcisoft.core.task;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.sys.role.dao.SysRoleRepository;
import org.rcisoft.sys.user.service.SysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by lz on 20/6/19.
 */
@Component
@Slf4j
public class UserManageTask {


    @Autowired
    private SysUserService sysUserService;

    @Autowired
    private SysRoleRepository sysRoleRepository;

    @Scheduled(cron = "${eduJob.userManageJob:0 0/5 * * * ?}")
    public void work()  {
        //获取 智学开通所有企业id
        List<String> corpIds = sysRoleRepository.getCorpIds();
        log.info("------UserManageTask----定时任务调用获取当前企业ids-"+corpIds);
        //循环调用  同步接口
        corpIds.forEach(c->sysUserService.synchronizedALL(c));
    }
}
