package org.rcisoft.core.util;

import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.common.util.feignDto.UserInfoDTO;
import org.rcisoft.core.entity.IdEntity;
import org.rcisoft.sys.user.bean.CurUser;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by lcy on 17/11/28.
 */
public class UserUtil {

    /**
     * 用户id
     */
    public static final String USER_ID = "businessId";
    /**
     * 用户 username
     */
    public static final String USER_USERNAME = "username";

    /**
     * 用户 userid
     */
    public static final String USER_MODEL = "model";

    private static ThreadLocal<Map> local = new ThreadLocal<>();

    /**
     * 设置登陆人
     * @param obj
     */
    public static void setCurUser(CurUser obj){
        Map<String,Object> user = null;
        user = local.get();
        if(null == user)
            user = new HashMap<>();
        //设置请求id
        obj.setRequireId(IdGen.uuid());
        user.put(UserUtil.USER_MODEL,obj);
        local.set(user);
   }

    /**
     * 设置当前实体信息
     * @param model
     */
    public static void setCurrentPersistOperation(IdEntity model) {
        model.setCreateDate(new Date());
        model.setUpdateDate(new Date());
        model.setCommonBusinessId();
        model.setNotDeleted();
        model.setStart();
        CurUser curUser = UserUtil.getCurUser();
        if(null == curUser)
            return;
        model.setCreateBy(curUser.getUserId());
        model.setUpdateBy(curUser.getUserId());
        model.setCorpId(curUser.getCorpId());
    }
    /**
     * 修改当前实体信息
     * @param model
     */
    public static void setCurrentMergeOperation(IdEntity model) {
        model.setUpdateDate(new Date());
        CurUser curUser = UserUtil.getCurUser();
        if(null == curUser)
            return;
        model.setUpdateBy(curUser.getUserId());
    }

    /**
     * 获取当前登陆人
     * @return
     */
    public static CurUser getCurUser(){
        Map map = local.get();
        if(null == map || null == map.get(USER_MODEL))
            return null;
        Object obj = map.get(USER_MODEL);
        if(! (obj instanceof CurUser))
            return null;
        return (CurUser) obj;
    }
}
